//RahmenSperren_502d.js
// 22.05.15 / Hans Haesler, Chtelard 52, CH-1018 Lausanne / <hsa@ringier.ch>
//DESCRIPTION:Objekte sperren

// vorbeugenderweise das Anzeigen von Dialogen aktivieren
app.scriptPreferences.userInteractionLevel = UserInteractionLevels.interactWithAll;

// prfen, ob ein Dokument geffnet ist
if (app.documents.length == 0) {
	alert ("Es ist kein Dokument offen.", "Achtung");
	exit();
}

// die Funktion aufrufen, welche die gespeicherten Vorgaben einliest
var allPrefs  = getPrefs();
if (allPrefs != "") {
	var prefVal = allPrefs.split("\n");
	var cVal1   = prefVal[0];
	var cVal2   = prefVal[1];
	var cVal3   = prefVal[2];
	var cVal4   = prefVal[3];
	var cVal5   = prefVal[4];
	var rVal1   = prefVal[5];
	var cVal6   = prefVal[6];
	var rVal2   = prefVal[7];
	var pNum    = prefVal[8];
	ck01 = ck02 = ck03 = ck04 = ck05 = ck06 = 1;
	if (cVal1  == "false") { ck01 = 0; }
	if (cVal2  == "false") { ck02 = 0; }
	if (cVal3  == "false") { ck03 = 0; }
	if (cVal4  == "false") { ck04 = 0; }
	if (cVal5  == "false") { ck05 = 0; }
	rb01 = rb05 = 1;
	rb02 = rb03 = rb04 = rb06 = 0;
	if (rVal1  == "1") {
		rb01 = 0;
		rb02 = 1;
	}
	else if (rVal1 == "2") {
		rb01 = 0;
		rb03 = 1;
	}
	else if (rVal1 == "3") {
		rb01 = 0;
		rb04 = 1;
	}
	if (cVal6  == "false") { ck06 = 0; }
	if (rVal2  == "1") {
		rb05 = 0;
		rb06 = 1;
	}
}
else {
	// wenn die Prferenzen-Datei nicht gefunden wurde, 
	// auf die folgenden Vorgabenwerte zurckgreifen
	ck01 =  1;
	ck02 =  1;
	ck03 =  1;
	ck04 =  1;
	ck05 =  1;
	rb01 =  0;
	rb02 =  1;
	rb03 =  0;
	rb04 =  0;
	ck06 =  1;
	rb05 =  1;
	rb06 =  0;
	pNum = "";
}

// den Dialog zum Entscheiden anzeigen
var userDec = askUser1();

// den Variablen das Ergebnis zuweisen
textFrm = userDec[0];
pictFrm = userDec[1];
noneFrm = userDec[2];
lineFrm = userDec[3];
grpeFrm = userDec[4];
docuRge = userDec[5];
actLayr = userDec[6];
anchObj = userDec[7];

// die gewnschten Rahmentypen prfen
var frameTypes = 0;
if (textFrm == true) {
	frameTypes += 1;
}
if (pictFrm == true) {
	frameTypes += 2;
}
if (noneFrm == true) {
	frameTypes += 4;
}
if (lineFrm == true) {
	frameTypes += 8;
}
if (grpeFrm == true) {
	frameTypes += 16;
}
if (frameTypes == 0) {
	alert ("Mindestens eine Rahmensorte auswhlen.", "Stop", true);
	exit();
}

// die aktive Ebene speichern
if (actLayr) {
	curLayer = app.activeWindow.activeLayer;
}

// je nach Wunsch die Aktion auslsen
if (docuRge == 0) { // "die ausgewhlten Rahmen"
	var tgtFrames = app.selection;
	var nFrames   = tgtFrames.length;
	if (nFrames == 0) {
		alert ("Es ist nichts ausgewhlt.", "Stop");
		exit();
	}
	prepLock(tgtFrames, nFrames);
}
else if (docuRge == 1) { // "auf dem aktuellen Druckbogen"
	var tgtFrames = app.activeWindow.activeSpread.pageItems.everyItem().getElements();
	var nFrames   = tgtFrames.length;
	prepLock(tgtFrames, nFrames);
}
else if (docuRge == 2) { // "im zu definierenden Seitenbereich"
	var curDoc = app.documents[0];
	// prfen, ob Abschnitts-Prfizes definiert sind
	sectPrefs = false;
	var allPrefNames = new Array();
	for (var p=0; p<curDoc.pages.length; p++) {
		var curSect = curDoc.pages[p].appliedSection.name;
		allPrefNames.push(curSect);
	}
	var testString = allPrefNames.join("");
	if (testString.length > 0) {
		sectPrefs = true;
	}
	// die Liste der Seitennummern
	if (sectPrefs == false) {
		allPageNames = curDoc.pages.everyItem().name;
	}
	else {
		var allPageNames = new Array();
		for (var p=0; p<curDoc.pages.length; p++) {
			var curName = curDoc.pages[p].name;
			allPageNames.push(allPrefNames[p] + curName);
		}
	}
	// den Dialog zum Eingeben des Seitenbereichs aufrufen
	var pageRange = askUser2();
	// die Eingabe prfen lassen
	if (sectPrefs == false) {
		allPages = rangeNoSectPref(pageRange);
	}
	else {
		allPages = rangeWithSectPref(pageRange);
	}
	// eine Schleife durch die Seiten
	for (var p=0; p<allPages.length; p++) {
		var tgtFrames = app.documents[0].pages[allPages[p]].pageItems.everyItem().getElements();
		var nFrames   = tgtFrames.length;
		prepLock(tgtFrames, nFrames)
	}
}
else if (docuRge == 3) { // "im ganzen Dokument"
	var tgtFrames = app.documents[0].pageItems.everyItem().getElements();
	var nFrames   = tgtFrames.length;
	prepLock(tgtFrames, nFrames);
}

// die Liste der Einstellungen ...
var prefsList = new Array(textFrm, pictFrm, noneFrm, lineFrm, grpeFrm, docuRge, actLayr, anchObj, pageRange);
// ... in eine Textkette verwandeln ...
var prefString = prefsList.join("\n");
// ... zur Funktion schicken, welche sie in eine Datei schreibt ...
writeResult(prefString);

// das Ende der Aktion verknden
var dlog = new Window("palette");
dlog.size = [320,100];
dlog.add("statictext", [80, 100, 320, 116], "Fertig.");
dlog.show();
// eine kleine Pause
$.sleep(999);
// das Fenster schliessen
dlog.close();


////////////////////////////// die Funktionen  ////////////////////////////////////////////////////

// die Funktion, welche die Informationen vorbereitet /////////////////////////////////////////////
function getPrefs() {
	var allPrefs = "";
	// die Datei lesen, welche die gespeicherten Werte enthlt
	if ($.os.slice(0,7) == "Windows") {
		var tempFolder = Folder.temp;
		var f = File(tempFolder + "/RahmenSperren_502.txt");
	}
	else {
		var f = new File("~/Library/Preferences/RahmenSperren_502.txt");
	}
	var fileIsOpen = f.open("r");
	if (fileIsOpen) {
		try {
			allPrefs = f.read();
			f.close();
		}
		catch (e) {
			try {
				f.close();
			}
			catch (e) {
			}
		}
	}
	return allPrefs;
}

// den ersten Entscheidungs-Dialog vorbereiten und anzeigen ///////////////////////////////////////
function askUser1() {
	try {
		app.dialogs.everyItem().destroy();
	}
	catch (e) {
	}
	var labelWidth0 = 16;
	var labelWidth1 =  4;
	var labelWidth2 = 88;
	var labelWidth3 = 94;
	var aDialog = app.dialogs.add({name:"RahmenSperren"});
	with (aDialog) {
		with (dialogColumns.add()) {
			with (dialogRows.add()) {
				staticTexts.add({staticLabel:"Was und wo soll gesperrt werden?"});
				staticTexts.add({staticLabel:" ", minWidth:labelWidth1});
			}
			with (dialogRows.add()) {
				staticTexts.add({staticLabel:" ", minWidth:labelWidth0});
				var checkbox01 = checkboxControls.add({staticLabel:"Textrahmen", checkedState:ck01, minWidth:labelWidth2});
			}
			with (dialogRows.add()) {
				staticTexts.add({staticLabel:" ", minWidth:labelWidth0});
				var checkbox02 = checkboxControls.add({staticLabel:"Bildrahmen", checkedState:ck02, minWidth:labelWidth2});
			}
			with (dialogRows.add()) {
				staticTexts.add({staticLabel:" ", minWidth:labelWidth0});
				var checkbox03 = checkboxControls.add({staticLabel:"Inhalt nicht zugewiesen", checkedState:ck03, minWidth:labelWidth2});
			}
			with (dialogRows.add()) {
				staticTexts.add({staticLabel:" ", minWidth:labelWidth0});
				var checkbox04 = checkboxControls.add({staticLabel:"Linienrahmen", checkedState:ck04, minWidth:labelWidth2});
			}
			with (dialogRows.add()) {
				staticTexts.add({staticLabel:" ", minWidth:labelWidth0});
				var checkbox05 = checkboxControls.add({staticLabel:"Gruppen", checkedState:ck05, minWidth:labelWidth2});
			}
			with (dialogRows.add()) {
				with (borderPanels.add()) {
					with (dialogColumns.add()) {
						with (dialogRows.add()) {
							staticTexts.add({staticLabel:" ", minWidth:labelWidth1});
							with(refButtons1 = radiobuttonGroups.add()) {
								radiobuttonControls.add({staticLabel:"die ausgewhlten Rahmen", checkedState:rb01});
								radiobuttonControls.add({staticLabel:"auf dem aktuellen Druckbogen", checkedState:rb02});
								radiobuttonControls.add({staticLabel:"im zu definierenden Seitenbereich", checkedState:rb03});
								radiobuttonControls.add({staticLabel:"im ganzen Dokument", checkedState:rb04});
							}
						}
					}
				}
			}
			with (dialogRows.add()) {
				staticTexts.add({staticLabel:" ", minWidth:labelWidth0});
				var checkbox06 = checkboxControls.add({staticLabel:"nur auf der aktiven Ebene", checkedState:ck06, minWidth:labelWidth2});
			}
			with (dialogRows.add()) {
				with (borderPanels.add()) {
					with (dialogColumns.add()) {
						with (dialogRows.add()) {
							staticTexts.add({staticLabel:"Verankerte Rahmen ..."});
							staticTexts.add({staticLabel:" ", minWidth:labelWidth3});
						}
						with (dialogRows.add()) {
							staticTexts.add({staticLabel:" ", minWidth:labelWidth1});
							with(refButtons2 = radiobuttonGroups.add()) {
								radiobuttonControls.add({staticLabel:"entsperrt lassen", checkedState:rb05});
								radiobuttonControls.add({staticLabel:"ebenfalls sperren", checkedState:rb06});
							}
						}
					}
				}
			}
		}
	}
	if(aDialog.show() == true) {
		ck01 = checkbox01.checkedState;
		ck02 = checkbox02.checkedState;
		ck03 = checkbox03.checkedState;
		ck04 = checkbox04.checkedState;
		ck05 = checkbox05.checkedState;
		var refDec1 = refButtons1.selectedButton;
		ck06 = checkbox06.checkedState;
		var refDec2 = refButtons2.selectedButton;
		// den Dialog entfernen
		aDialog.destroy();
		// die Werte zurckschicken
		return [ck01, ck02, ck03, ck04, ck05, refDec1, ck06, refDec2];
	}
	else {
		aDialog.destroy();
		exit();
	}
}

// den zweiten Dialog vorbereiten und anzeigen ////////////////////////////////////////////////////
function askUser2() {
	var fieldWidth  = 350;
	var aDialog = app.dialogs.add({name:"RahmenSperren"});
	with (aDialog) {
		with (dialogColumns.add()) {
			with (dialogRows.add()) {
				staticTexts.add({staticLabel:"Seitenbereich(e) eingeben (z.B. 1, 2-3, 4-7, 8):"});
				staticTexts.add({staticLabel:" ", minWidth:10});
			}
			with (dialogRows.add()) {
				var pagesField = textEditboxes.add({editContents:pNum, minWidth:fieldWidth});
			}
		}
		with (dialogColumns.add()) {
			with (dialogRows.add()) {
				staticTexts.add({staticLabel:" ", minWidth:4});
			}
		}
	}
	if(aDialog.show() == true) {
		pNum = pagesField.editContents;
		// den Dialog entfernen
		aDialog.destroy();
		// ... und nach der Prfung ...
		if (pNum == "") {
			alert ("Seitenbereich(e):\n\nDas Eingabefeld ist leer.", "Stop");
			exit();
		}
		// ... ebenfalls zurck zum Aufruf
		return pNum;
	}
	else {
		aDialog.destroy();
		exit();
	}
}

// die Liste der Seitenzahlen aufstellen und prfen ///////////////////////////////////////////////
function rangeNoSectPref(pageRange) {  // wenn keine Abschnittsprfizes definiert sind ////////////
	var whatKind = 0;
	var pagesList = new Array();
	var indList   = new Array();
	// Leerschlge entfernen
	var newRange = pageRange.split(" ");
	newRange = newRange.join("");
	// prfen, ob Kommas und/oder Bindestriche und/oder Pluszeichen enthalten sind
	if (newRange.indexOf("-") != -1) {
		whatKind = whatKind + 1;
	}
	if (newRange.indexOf(",") != -1) {
		whatKind = whatKind + 2;
	}
	if (newRange.indexOf("+") != -1) {
		whatKind = whatKind + 4;
	}
	// je nach Art der Kette die Listen erstellen
	if (whatKind == 0) {
		pagesList.push(newRange);
	}
	else if (whatKind == 1) {
		var newRangeList = newRange.split("-");
		var startVal = newRangeList[0]*1;
		var stopVal  = (newRangeList[1]*1);
		if (startVal<stopVal) {
			for (var i=startVal; i<stopVal+1; i++) {
				pagesList.push(""+i);
			}
		}
		else {
			for (var i=stopVal; i<startVal+1; i++) {
				pagesList.push(""+i);
			}
		}
	}
	else if (whatKind == 2) {
		var newRangeList = newRange.split(",");
		for (var i=0; i<newRangeList.length; i++) {
			pagesList.push(newRangeList[i]);
		}
	}
	else if (whatKind == 3) {
		var newRangeList = newRange.split(",");
		for (var i=0; i<newRangeList.length; i++) {
			var tmpItem = newRangeList[i];
			if (tmpItem.indexOf("-") != -1) {
				var tmpItemList = tmpItem.split("-");
				var startVal = tmpItemList[0]*1;
				var stopVal  = (tmpItemList[1]*1);
				if (startVal<stopVal) {
					for (var k=startVal; k<stopVal+1; k++) {
						pagesList.push(""+k);
					}
				}
				else {
					for (var k=stopVal; k<startVal+1; k++) {
						pagesList.push(""+k);
					}
				}
			}
			else {
				pagesList.push(newRangeList[i]);
			}
		}
	}
	else if (whatKind == 4) {
		indList.push((newRange*1)-1);
	}
	else if (whatKind == 5) {
		var newRangeList = newRange.split("-");
		var startVal = (newRangeList[0]*1);
		var stopVal  = (newRangeList[1]*1);
		if (startVal<stopVal) {
			for (var i=startVal-1; i<stopVal; i++) {
				indList.push(i);
			}
		}
		else {
			for (var i=stopVal-1; i<startVal; i++) {
				indList.push(i);
			}
		}
	}
	else if (whatKind == 6) {
		var newRangeList = newRange.split(",");
		for (var i=0; i<newRangeList.length; i++) {
			if (newRangeList[i][0] == "+") {
				indList.push((newRangeList[i]*1)-1);
			}
			else {
				var okay = false;
				for (var k=0; k<allPageNames.length; k++) {
					if (newRangeList[i] == allPageNames[k]) {
						indList.push(k);
						okay = true;
						break;
					}
				}
				if (!okay) {
					alert ("Die Seite " + newRangeList[i] + " ist nicht vorhanden.", "Stop");
					exit();
				}
			}
		}
	}
	else if (whatKind == 7) {
		var newRangeList = newRange.split(",");
		for (var i=0; i<newRangeList.length; i++) {
			var tmpItem = newRangeList[i];
			if (tmpItem.indexOf("-") != -1) {
				var tmpItemList = tmpItem.split("-");
				var startVal = (tmpItemList[0]*1);
				var stopVal  = (tmpItemList[1]*1);
				if (startVal<stopVal) {
					for (var k=startVal-1; k<stopVal; k++) {
						indList.push(k);
					}
				}
				else {
					for (var k=stopVal-1; k<startVal; k++) {
						indList.push(k);
					}
				}
			}
			else {
				if (newRangeList[i][0] == "+") {
					indList.push((newRangeList[i]*1)-1);
				}
				else {
					var okay = false;
					for (var k=0; k<allPageNames.length; k++) {
						if (newRangeList[i] == allPageNames[k]) {
							indList.push(k);
							okay = true;
							break;
						}
					}
					if (!okay) {
						alert ("Die Seite " + newRangeList[i] + " ist nicht vorhanden.", "Stop");
						exit();
					}
				}
			}
		}
	}
	// prfen, ob die gewnschten Seiten existieren
	if (whatKind < 4) {
		var nNum = pagesList.length;
		for (var i=0; i<nNum; i++) {
			var okay = false;
			var actNum = pagesList[i];
			for (var k=0; k<allPageNames.length; k++) {
				if (actNum == allPageNames[k]) {
					okay = true;
					indList.push(k);
					break;
				}
			}
		}
		if (okay) {
			return indList;
		}
		else {
			alert ("Die Seite " + actNum + " ist nicht vorhanden.", "Stop");
			exit();
		}
	}
	else {
		var maxInd = (allPageNames.length)-1;
		for (var i=0; i<indList.length; i++) {
			if (indList[i] > maxInd) {
				alert ("Die Seite +" + (indList[i]+1) + " ist nicht vorhanden.", "Stop");
				exit();
			}
		}
	}
	return indList;
}

function rangeWithSectPref(pageRange) {  // wenn Abschnittsprfizes definiert sind ////////////////
	var whatKind = 0;
	var indList  = new Array();
	// Leerschlge entfernen
	var newRange = pageRange.split(" ");
	newRange = newRange.join("");
	// prfen, ob Kommas und/oder Bindestriche und/oder Pluszeichen enthalten sind
	if (newRange.indexOf("-") != -1) {
		whatKind = whatKind + 1;
	}
	if (newRange.indexOf(",") != -1) {
		whatKind = whatKind + 2;
	}
	if (newRange.indexOf("+") != -1) {
		whatKind = whatKind + 4;
	}
	// je nach Art der Kette die Liste(n) der Seiten erstellen
	if (whatKind == 0) {
		var startVal  = -1;
		for (var n=0; n<allPageNames.length; n++) {
			if (allPageNames[n] == newRange) {
				startVal = n;
				break;
			}
		}
		if (startVal != -1) {
			indList.push(n);
		}
		else {
			alert ("Die Seite " + newRange + " existiert nicht.", "Stop");
			exit();
		}
	}
	else if (whatKind == 1) {
		var startVal = -1;
		for (var n=0; n<allPageNames.length; n++) {
			if (allPageNames[n] == newRange) {
				startVal = n;
				break;
			}
		}
		if (startVal != -1) {
			indList.push(n);
		}
		else {
			var newRangeList = newRange.split("-");
			if (newRangeList.length == 2) {
				var startPage = newRangeList[0];
				var stopPage  = newRangeList[1];
			}
			else if (newRangeList.length == 3) {
				var startVal  = -1;
				var startPage = newRangeList[0];
				for (var n=0; n<allPageNames.length; n++) {
					if (allPageNames[n] == startPage) {
						startVal = n;
						break;
					}
				}
				if (startVal != -1) {
					var stopPage  = newRangeList[1]+"-"+newRangeList[2];
				}
				else {
					var startPage = newRangeList[0]+"-"+newRangeList[1];
					var stopPage  = newRangeList[2];
				}
			}
			else if (newRangeList.length == 4) {
				var startPage = newRangeList[0]+"-"+newRangeList[1];
				var stopPage  = newRangeList[2]+"-"+newRangeList[3];
			}
			var startVal  = -1;
			var stopVal   = -1;
			for (var n=0; n<allPageNames.length; n++) {
				if (allPageNames[n] == startPage) {
					startVal = n;
					break;
				}
			}
			for (var n=0; n<allPageNames.length; n++) {
				if (allPageNames[n] == stopPage) {
					stopVal = n;
					break;
				}
			}
			if (startVal == -1) {
				alert ("Die Seite " + startPage + " existiert nicht.", "Stop");
				exit();
			}
			if (stopVal == -1) {
				alert ("Die Seite " + stopPage + " existiert nicht.", "Stop");
				exit();
			}
			if (startVal<stopVal) {
				for (var i=startVal; i<stopVal+1; i++) {
					indList.push(i);
				}
			}
			else {
				for (var i=stopVal; i<startVal+1; i++) {
					indList.push(i);
				}
			}
		}
	}
	else if (whatKind == 2) {
		var newRangeList = newRange.split(",");
		var startPage = newRangeList[0];
		var stopPage  = newRangeList[1];
		var startVal  = -1;
		var stopVal   = -1;
		for (var n=0; n<allPageNames.length; n++) {
			if (allPageNames[n] == startPage) {
				startVal = n;
				indList.push(n);
				break;
			}
		}
		for (var n=0; n<allPageNames.length; n++) {
			if (allPageNames[n] == stopPage) {
				stopVal = n;
				indList.push(n);
				break;
			}
		}
		if (startVal == -1) {
			alert ("Die Seite " + startPage + " existiert nicht.", "Stop");
			exit();
		}
		if (stopVal == -1) {
			alert ("Die Seite " + stopPage + " existiert nicht.", "Stop");
			exit();
		}
	}
	else if (whatKind == 3) {
		var newRangeList = newRange.split(",");
		for (var i=0; i<newRangeList.length; i++) {
			var tmpItem = newRangeList[i];
			if (tmpItem.indexOf("-") != -1) {
				var startVal = -1;
				for (var n=0; n<allPageNames.length; n++) {
					if (allPageNames[n] == tmpItem) {
						startVal = n;
						break;
					}
				}
				if (startVal != -1) {
					startPage = tmpItem;
					stopPage  = tmpItem;
				}
				else {
					var tmpList = tmpItem.split("-");
					if (tmpList.length == 2) {
						var startPage = tmpList[0];
						var stopPage  = tmpList[1];
					}
					else if (tmpList.length == 3) {
						var startVal  = -1;
						var startPage = tmpList[0];
						for (var n=0; n<allPageNames.length; n++) {
							if (allPageNames[n] == startPage) {
								startVal = n;
								break;
							}
						}
						if (startVal != -1) {
							var stopPage  = tmpList[1]+"-"+tmpList[2];
						}
						else {
							var startPage = tmpList[0]+"-"+tmpList[1];
							var stopPage  = tmpList[2];
						}
					}
					else if (tmpList.length == 4) {
						var startPage = tmpList[0]+"-"+tmpList[1];
						var stopPage  = tmpList[2]+"-"+tmpList[3];
					}
				}
				var startVal  = -1;
				var stopVal   = -1;
				for (var n=0; n<allPageNames.length; n++) {
					if (allPageNames[n] == startPage) {
						startVal = n;
						break;
					}
				}
				for (var n=0; n<allPageNames.length; n++) {
					if (allPageNames[n] == stopPage) {
						stopVal = n;
						break;
					}
				}
				if (startVal == -1) {
					alert ("Die Seite " + startPage + " existiert nicht.", "Stop");
					exit();
				}
				if (stopVal == -1) {
					alert ("Die Seite " + stopPage + " existiert nicht.", "Stop");
					exit();
				}
				if (startVal<stopVal) {
					for (var k=startVal; k<stopVal+1; k++) {
						indList.push(k);
					}
				}
				else {
					for (var k=stopVal; k<startVal+1; k++) {
						indList.push(k);
					}
				}
			}
			else {
				var startPage = newRangeList[i];
				var startVal  = -1;
				for (var n=0; n<allPageNames.length; n++) {
					if (allPageNames[n] == startPage) {
						startVal = n;
						break;
					}
				}
				if (startVal != -1) {
					indList.push(n);
				}
				else {
					alert ("Die Seite " + startPage + " existiert nicht.", "Stop");
					exit();
				}
			}
		}
	}
	else if (whatKind == 4) {
		indList.push((newRange*1)-1);
	}
	else if (whatKind == 5) {
		var newRangeList = newRange.split("-");
		var startVal = (newRangeList[0]*1);
		var stopVal  = (newRangeList[1]*1);
		if (startVal<stopVal) {
			for (var i=startVal-1; i<stopVal; i++) {
				indList.push(i);
			}
		}
		else {
			for (var i=stopVal-1; i<startVal; i++) {
				indList.push(i);
			}
		}
	}
	else if (whatKind == 6) {
		var newRangeList = newRange.split(",");
		for (var i=0; i<newRangeList.length; i++) {
			if (newRangeList[i][0] == "+") {
				indList.push((newRangeList[i]*1)-1);
			}
			else {
				var okay = false;
				for (var k=0; k<allPageNames.length; k++) {
					if (newRangeList[i] == allPageNames[k]) {
						indList.push(k);
						okay = true;
						break;
					}
				}
				if (!okay) {
					alert ("Die Seite " + newRangeList[i] + " ist nicht vorhanden.", "Stop");
					exit();
				}
			}
		}
	}
	else if (whatKind == 7) {
		var newRangeList = newRange.split(",");
		for (var i=0; i<newRangeList.length; i++) {
			var tmpItem = newRangeList[i];
			if (tmpItem.indexOf("-") != -1) {
				var tmpItemList = tmpItem.split("-");
				var startVal = (tmpItemList[0]*1);
				var stopVal  = (tmpItemList[1]*1);
				if (startVal<stopVal) {
					for (var k=startVal-1; k<stopVal; k++) {
						indList.push(k);
					}
				}
				else {
					for (var k=stopVal-1; k<startVal; k++) {
						indList.push(k);
					}
				}
			}
			else {
				if (newRangeList[i][0] == "+") {
					indList.push((newRangeList[i]*1)-1);
				}
				else {
					var okay = false;
					for (var k=0; k<allPageNames.length; k++) {
						if (newRangeList[i] == allPageNames[k]) {
							indList.push(k);
							okay = true;
							break;
						}
					}
					if (!okay) {
						alert ("Die Seite " + newRangeList[i] + " ist nicht vorhanden.", "Stop");
						exit();
					}
				}
			}
		}
	}
	// prfen, ob die gewnschten Seiten existieren
	if (whatKind > 3) {
		var maxInd = (allPageNames.length)-1;
		for (var i=indList.length-1; i>-1; i--) {
			if (indList[i] > maxInd) {
				alert ("Die Seite +" + (indList[i]+1) + " ist nicht vorhanden.", "Stop");
				exit();
			}
		}
	}
	return indList;
}

// das Sperren vorbereiten ////////////////////////////////////////////////////////////////////////
function prepLock(tgtFrames, nFrames) {
	for (var n=0; n<nFrames; n++) {
		var grabAll  = true;
		var curFrame = tgtFrames[n];
		if (actLayr) {
			try {
				if (curFrame.itemLayer != curLayer) {
					continue;
				}
			}
			catch (e) {
				continue;
			}
		}
		var curType  = curFrame.constructor.name;
		if (curType == "Group") {
			grabAll = false;
		}
		if (frameTypes == 31) {
			lockOne(curFrame);
		}
		else {
			if (curType == "Rectangle" || curType == "Oval") {
				curType = (curFrame.contentType)*1;
			}
			else if (curType == "Polygon") {
				var actPath = (curFrame.paths[0].pathType)*1;
				if (actPath == 1668051812) { // = geschlossener Pfad
					curType = (curFrame.contentType)*1;
				}
				else if (actPath == 1869639280) { // = offener Pfad
					if (curFrame.textPaths[0].isValid) {
						curType = "TextFrame";
					}
					else {
						curType = "GraphicLine";
					}
				}
			}
			if (checkType(frameTypes, curType)) {
				lockOne(curFrame);
			}
		}
		if (grabAll) {
			var allFrames = curFrame.allPageItems;
			var nnnFrames = allFrames.length;
			if (nnnFrames > 0) {
				for (var k=0; k<nnnFrames; k++) {
					var curFrame = allFrames[k];
					if (frameTypes == 31) {
						lockOne(curFrame);
					}
					else {
						var curType = curFrame.constructor.name;
						if (curType == "Rectangle" || curType == "Oval") {
							curType = (curFrame.contentType)*1;
						}
						else if (curType == "Polygon") {
							var actPath = (curFrame.paths[0].pathType)*1;
							if (actPath == 1668051812) { // = geschlossener Pfad
								curType = (curFrame.contentType)*1;
							}
							else if (actPath == 1869639280) { // = offener Pfad
								if (curFrame.textPaths[0].isValid) {
									curType = "TextFrame";
								}
								else {
									curType = "GraphicLine";
								}
							}
						}
						if (checkType(frameTypes, curType)) {
							lockOne(curFrame);
						}
					}
				}
			}
		}
	}
}

// die Rahmenart prfen ///////////////////////////////////////////////////////////////////////////
function checkType(frameTypes, curType) {
	var typeNbr = "|"+frameTypes+"|";
	if (curType == "TextFrame" || curType == 1952412773) { // = Textrahmen
		if (("|1|3|5|7|9|11|13|15|17|19|21|23|25|27|29|").indexOf(typeNbr) != -1) {
			return true;
		}
	}
	else if (curType == 1735553140) { // = Bildrahmen
		if (("|2|3|6|7|10|11|14|18|19|22|23|25|27|30|").indexOf(typeNbr) != -1) {
			return true;
		}
	}
	else if (curType == 1970168179) { // = nicht zugewiesen
		if (("|4|5|6|7|12|13|14|15|20|21|22|23|28|29|30|").indexOf(typeNbr) != -1) {
			return true;
		}
	}
	else if (curType == "GraphicLine") { // = Linienrahmen
		if (("|8|9|10|11|12|13|14|15|24|25|26|27|28|29|30|").indexOf(typeNbr) != -1) {
			return true;
		}
	}
	else if (curType == "Group") { // = Gruppe
		if (("|16|17|18|19|20|21|22|23|24|25|26|27|28|29|30|").indexOf(typeNbr) != -1) {
			return true;
		}
	}
	return false;
}

// die Rahmen sperren /////////////////////////////////////////////////////////////////////////////
function lockOne(oneFrame) {
	if (oneFrame.parent != "[object Character]") {
		// ist der Rahmen nicht gesperrt ...
		if (oneFrame.locked == false) {
			// ... den Rahmen sperren
			try {
				oneFrame.locked = true;
			}
			catch (e) {
			}
		}
	}
	else {
		// wenn verankerte Rahmen auch gesperrt werden sollen
		if (anchObj == 1) {
			// ist der Rahmen nicht gesperrt ...
			if (oneFrame.locked == false) {
				// ... den Rahmen sperren
				try {
					oneFrame.locked = true;
				}
				catch (e) {
				}
			}
			// wenn "Manuelle Positionierung verhindern" nicht an ist ...
			if (oneFrame.anchoredObjectSettings.lockPosition == false) {
				// ... den Haken setzen
				oneFrame.anchoredObjectSettings.lockPosition = true;
			}
		}
	}
}

// das Ergebnis in eine Datei schreiben ///////////////////////////////////////////////////////////
function writeResult(prefString) {
	if ($.os.slice(0,7) == "Windows") {
		var tempFolder = Folder.temp;
		var f = File(tempFolder + "/RahmenSperren_502.txt");
	}
	else {
		var f = new File("~/Library/Preferences/RahmenSperren_502.txt");
	}
	var fileIsOpen = f.open("w");
	if (fileIsOpen) {
		try {
			f.write(prefString);
			f.close();
		}
		catch (e) {
			try {
				f.close();
			}
			catch (e) {
			}
		}
	}
}